# spring-rest-example

This project is a example of using Spring REST.

The project uses the [Spock Framework Example Project](https://github.com/spockframework/)

## Prerequisites

- JDK 17 or higher

- Maven use `mvnw` wrapper

## Building with Maven

Downloaded files will be stored in the local Maven repository (typically **user_home**`/.m2/repository`).

Type: test

```shell
./mvnw clean test
```

Type: build


```shell
./mvnw clean install -DskipTests=true
# or
make war
```

Type: preparation
- create a folder, for example, `project`.
- copy `SpringRestExample.war` from a release to `target/` in the folder.
  - if you build the application from source, skip this step.
- copy `Dockerfile` and `docker-compose.yml` to the folder.
- turn up the project in the `project`:
  ```
  docker-compose up -d --build
  ```
- wait a minute while the database is bootstrapping.
- now you can connect to the application.

## Author

Kostiantyn Klochko (c) 2023

