package space.kklochko.spring_rest_example.security.hashes


import spock.lang.Specification;
import spock.lang.Subject;

public class Sha256HashSpec extends Specification {
    def "Create a token that based on sha256"() {
        given: "I have a hasher"
        @Subject
        def hasher = new Sha256Hash()

        when: "I get a hash of a string"
        String hash = hasher.hashOf(input)

        then: "The token is the same if the same input data."
        expectedHash == hash

        where: "I have the expected data"
        input                  || expectedHash
        "abc"                  || "ba7816bf8f01cfea414140de5dae2223b00361a396177a9cb410ff61f20015ad"
        "random numbers232341" || "7f4b80b2b09ae4326f78b1a9782c807af0a7d0194bffb05602a6585466b4c43e"
        "admin"                || "8c6976e5b5410415bde908bd4dee15dfb167a9c873fc4bb8a81f6f2ab448a918"
        "user"                 || "04f8996da763b7a969b1028ee3007569eaf3a635486ddab211d512c85b9df8fb"
    }
}

